<script setup lang="ts">
import Flex from "@/components/atoms/container/Flex.vue";
import {ref} from "vue";

const props = defineProps<{ onSubmit?: Function, onFailedSubmit?: Function }>()

const buttonRef = ref<HTMLButtonElement>()

const submitFormCallback = (e) => {
  const form: HTMLFormElement = e.target.form;
  if (form.checkValidity()) {
    e.preventDefault()
    props.onSubmit(e);
  } else {
    props.onFailedSubmit ? props.onFailedSubmit(e) : props.onFailedSubmit;
  }
}

const executeSubmit = () => {
  buttonRef.value?.click();
}

defineExpose({
  executeSubmit,
});
</script>

<template>
  <form ref="formRef">
    <Flex class="flex-col gap-content">
      <slot/>
    </Flex>
    <button type="submit" ref="buttonRef" @click="submitFormCallback" class="hidden"/>
  </form>
</template>